--- /home/mute/trunk/target/linux/adm8668/files/arch/mips/adm8668/prom.c	2011-02-18 19:05:07.000000000 +0000
+++ prom.c	2011-04-07 21:20:23.000000000 +0000
@@ -19,6 +19,7 @@
 #include <linux/console.h>
 #include <linux/string.h>
 #include <linux/serial_core.h>
+#include <linux/initrd.h>
 #include <asm/bootinfo.h>
 #include <adm8668.h>
 #include "u-boot.h"
@@ -117,6 +118,34 @@
 	*cp = '\0';
 }
 
+void __init prom_setup_env(void)
+{
+	char **prom_env;
+	int i;
+
+	initrd_start = initrd_end = 0;
+	prom_env = (char **)KSEG0ADDR(fw_arg2);
+
+	for (i = 0; prom_env[i]; i++)
+	{
+		prom_env[i] = (char *)KSEG0ADDR(prom_env[i]);
+		if (match_tag(prom_env[i], "initrd_start=")) {
+			char *ptr = prom_env[i] + strlen("initrd_start=");
+			initrd_start = simple_strtoul(ptr, 0, 16);
+			initrd_start = KSEG0ADDR(initrd_start);
+			/* incase size is passed first ... ? :p */
+			initrd_end  += initrd_start;
+		}
+
+		if (match_tag(prom_env[i], "initrd_size=")) {
+			char *ptr = prom_env[i] + strlen("initrd_size=");
+			initrd_end += simple_strtoul(ptr, 0, 16);
+		}
+	}
+	if (initrd_start)
+		printk("  initrd @ %#lx - %#lx\n", initrd_start, initrd_end);
+}
+
 void __init prom_init(void)
 {
 	bd_t *bd = gd->bd;
@@ -133,5 +162,6 @@
 	printk("  NOR size: %#lx\n", bd->bi_flashsize);
 
 	prom_setup_cmdline();
+	prom_setup_env();
 	add_memory_region(0, memsize, BOOT_MEM_RAM);
 }
